'use strict';

var _CssTask = require('../CssTask');

var _CssTask2 = _interopRequireDefault(_CssTask);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 |----------------------------------------------------------------
 | Sass Compilation Task
 |----------------------------------------------------------------
 |
 | This task will compile your Sass, including minification and
 | and auto-prefixing. Sass is one of the CSS pre-precessors
 | supported by Elixir, along with the Less CSS processor.
 |
 */

Elixir.extend('sass', function (src, output, baseDir, options) {
  new _CssTask2.default('sass', getPaths(src, baseDir, output), options);
});

/**
 * Prep the Gulp src and output paths.
 *
 * @param  {string|Array} src
 * @param  {string|null}  baseDir
 * @param  {string|null}  output
 * @return {GulpPaths}
 */
function getPaths(src, baseDir, output) {
  return new Elixir.GulpPaths().src(src, baseDir || Elixir.config.get('assets.css.sass.folder')).output(output || Elixir.config.get('public.css.outputFolder'), 'app.css');
};